#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QtOpenGL/QGLBuffer>
#include <QtOpenGL/QGLShaderProgram>
#include <QtOpenGL/QGLWidget>

#include <OpenGL/OpenGL.h>

class GLWidget : public QGLWidget
{
	Q_OBJECT
public:
	GLWidget(QWidget *parent = 0);

protected:
	virtual void initializeGL();
	virtual void resizeGL(int w, int h);
	virtual void paintGL();

	virtual void keyPressEvent(QKeyEvent *e);

private:
	CGLContextObj rootContext;

	GLuint rootQuadPositionBuffer;
	GLuint rootQuadElementBuffer;
	GLuint rootInputTexture;
	GLuint rootVertexShader;
	GLuint rootFragmentShader;
	GLuint rootProgram;
	GLint rootPositionAttribute;
	GLint rootTextureUniform;


	CGLContextObj childContext;

	GLuint childTexture;
	GLuint childFramebuffer;

	GLuint childQuadPositionBuffer;
	GLuint childQuadElementBuffer;

	GLuint childVertexShader;
	GLuint childFragmentShader;
	GLuint childProgram;
	GLint childPositionAttribute;
	GLint childTextureUniform;
	GLfloat childRenderTimeUniform;
};

#endif // GLWIDGET_H
